Codeforces Round #614 (Div. 2) D. Aroma‘s Search 暴力 + 思维

77 篇文章 0 订阅
15 篇文章 1 订阅

传送门

文章目录

题意:

给你 x 0 , y 0 , a x , a y , b x , b y x_0,y_0,a_x,a_y,b_x,b_y x0,y0,ax,ay,bx,by,让后根据 [ a x ∗ x i − 1 + b x , a y ∗ y i − 1 + b y ] [a_x*x_{i-1}+b_x,a_y*y_{i-1}+b_y] [axxi1+bx,ayyi1+by]构造出一堆有价值的点,让后有个起点 s x , s y s_x,s_y sx,sy,以及时间 t t t,每次可以往相邻位置移动一格,消耗 1 1 1秒时间,问能获得最多的价值是多少。

思路:

注意到 a x , a y > = 2 a_x,a_y>=2 ax,ay>=2,这个很重要,一开始没看见感觉很难就开始摆烂了 ,所以点数不会超过63个,也就是很少,而且点的排列方式一定是按照 x , y x,y x,y递增的,所以我们只需要确定起点和终点,让后跑就行了。因为点数很少,所以直接暴力枚举起点终点,检查答案即可。

//#pragma GCC optimize(2)
#include<cstdio>
#include<iostream>
#include<string>
#include<cstring>
#include<map>
#include<cmath>
#include<cctype>
#include<vector>
#include<set>
#include<queue>
#include<algorithm>
#include<sstream>
#include<ctime>
#include<cstdlib>
#define L (u<<1)
#define R (u<<1|1)
#define pb push_back
#define mk make_pair
#define Mid (tr[u].l+tr[u].r>>1)
#define Len(u) (tr[u].r-tr[u].l+1)
#define random(a,b) ((a)+rand()%((b)-(a)+1))
#define db puts("---")
using namespace std;

//void rd_cre() { freopen("d://dp//data.txt","w",stdout); srand(time(NULL)); }
//void rd_ac() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//AC.txt","w",stdout); }
//void rd_wa() { freopen("d://dp//data.txt","r",stdin); freopen("d://dp//WA.txt","w",stdout); }

typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int,int> PII;

const int N=1000010,mod=1e9+7,INF=0x3f3f3f3f;
const double eps=1e-6;
const LL M=30000000000000000;

int tot;
LL ax,ay,bx,by,sx,sy,t;
struct Node
{
    LL x,y;
}a[20000];

LL get_dis(int i,int j)
{
    return abs(a[i].x-a[j].x)+abs(a[i].y-a[j].y);
}

int main()
{
//	ios::sync_with_stdio(false);
//	cin.tie(0);


    LL x0,y0; tot=0;
    scanf("%lld%lld%lld%lld%lld%lld",&x0,&y0,&ax,&ay,&bx,&by);
    scanf("%lld%lld%lld",&sx,&sy,&t);
    a[++tot]={x0,y0};
    while(1)
    {
        if(a[tot].x>M||a[tot].y>M) break;
        a[++tot]={a[tot-1].x*ax+bx,a[tot-1].y*ay+by};
    }
    a[tot+1]={sx,sy};
    int ans=0;
    for(int i=1;i<=tot;i++)
        for(int j=1;j<=tot;j++)
            if(get_dis(i,tot+1)+get_dis(i,j)<=t)
                ans=max(ans,abs(i-j)+1);
    printf("%d\n",ans);



	return 0;
}
/*

*/



  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值